<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.17 Update #6                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2013 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.98.131123-190401                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Import
 * @copyright (C) 2002-2013 Esselbach Internet Solutions
 */

/**
 * function AdminImportNow
 * A function to import sources
 * @author Philipp Louis Esselbach
 */
function AdminImportNow( $step )
{
	global $database, $html, $system, $preferences, $otitle, $odescription, $olink, $login_username, $ipaddr, $words_import;

	if( !$step )
	{
		$step = 0;
	}

	$query = $database -> dbquery( "SELECT import_id, import_status, import_website, import_channels, import_name, import_email, import_source, import_hostname, import_username, import_password, import_newsgroup, import_newsmessages, import_allowcomments, import_html, import_smilies, import_code, import_teaser, import_whitelist, import_blacklist FROM " . DB_PREFIX . "esselbach_ct_import LIMIT " . $step . ", 1" );

	if( $database -> dbrows( $query ) )
	{
		list( $import_id, $import_status, $import_website, $import_channels, $import_name, $import_email, $import_source, $import_hostname, $import_username, $import_password, $import_newsgroup, $input_newsmessages, $import_comments, $import_html, $import_smilies, $import_code, $import_teaser, $import_whitelist, $import_blacklist ) = $database -> dbrow( $query );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_import SET import_date = now() WHERE import_id = '" . $import_id . "'" );
		$import_hostname = str_replace( "..", "", $import_hostname );

		if( !$import_source )
		{
			if( function_exists( "curl_exec" ) )
			{
				$feed = curl_init( $import_hostname );

				if( preg_match( "/https/i", $import_hostname ) )
				{
					curl_setopt( $feed, CURLOPT_PORT, 443 );
					curl_setopt( $feed, CURLOPT_SSL_VERIFYPEER, false );
				}

				curl_setopt( $feed, CURLOPT_RETURNTRANSFER, 1 );
				curl_setopt( $feed, CURLOPT_CONNECTTIMEOUT, 5 );

				if( $import_username && $import_password )
				{
					curl_setopt( $feed, CURLOPT_USERPWD, $import_username . ":" . $import_password );
				}

				curl_setopt( $feed, CURLOPT_USERAGENT, "Esselbach Contentteller CMS" );
				$data = curl_exec( $feed );
				curl_close( $feed );
			}
			else
			{
				$feed = @fopen( $import_hostname, "r" );
				$data = "";
				while( $output = fread( $feed, 4096 ))
				{
					$data .= $output;
				}
				fclose( $feed );
			}

			if( $preferences[ 'website_charset' ] == "ISO-8859-1" or $preferences[ 'website_charset' ] == "UTF-8" or $preferences[ 'website_charset' ] == "US-ASCII" )
			{
				$xml = xml_parser_create( $preferences[ 'website_charset' ] );
			}
			else
			{
				$xml = xml_parser_create();
			}

			xml_set_element_handler( $xml, "rssstart", "rssend" );
			xml_set_character_data_handler( $xml, "rssparse" );
			$success = xml_parse( $xml, $data );
			xml_parser_free( $xml );

			if ( $success )
			{
				for( $n = 0; $n < count( $otitle ); $n++ )
				{
					if( $import_whitelist && $import_blacklist )
					{
						$whitelist_array = explode( ",", $import_whitelist );
						$blacklist_array = explode( ",", $import_blacklist );

						for( $l = 0; $l < count( $whitelist_array ); $l++ )
						{

							if( preg_match( "/" . $whitelist_array[ $l ] . "/", $otitle[ $n ] ) or preg_match( "/" . $whitelist_array[ $l ] . "/", $odescription[ $n ] ) )
							{
								$new_title = $database -> dbescape( $system -> unhtmlchars( $otitle[ $n ] ) );
								$new_story = $database -> dbescape( $system -> unhtmlchars( $odescription[ $n ] ) . "\n\n[url=" . str_replace( array( "[ "," ]" ), array( "","" ), $olink[ $n ] ) . "]" . $system -> unhtmlchars( $otitle[ $n ] ) . "[/url]" );
							}


							if( preg_match( "/" . $blacklist_array[ $l ] . "/", $otitle[ $n ] ) or preg_match( "/" . $blacklist_array[ $l ] . "/", $odescription[ $n ] ) )
							{
								$new_title = "";
								$new_story = "";
							}
						}
					}
					else
					{
						$new_title = $database -> dbescape( $system -> unhtmlchars( $otitle[ $n ] ) );
						$new_story = $database -> dbescape( $system -> unhtmlchars( $odescription[ $n ] ) );
						$new_link = $database -> dbescape( $system -> unhtmlchars( str_replace( array( "[ "," ]" ), array( "","" ), $olink[ $n ] ) ) );
					}

					if( $new_title )
					{
						insertdata( $import_status, $login_username, $import_website, $import_email, $import_channels, $new_title, $new_story, $new_link, $import_teaser, $import_comments, $import_html, $import_smilies, $import_code, $ipaddr, $import_name );
					}
				}
			}
		}
		elseif( $import_source == 1 )
		{

			if( function_exists( "imap_open" ) )
			{
				$data = @imap_open( "{" . $import_hostname . ":110/pop3/notls}INBOX", $import_username, $import_password );
				$emails = imap_num_msg( $data );

				if( $emails )
				{

					for( $i = $emails; $i > 0; $i-- )
					{
						$headers = imap_header( $data, $i );
						$new_title = $database -> dbescape( quoted_printable_decode( $headers -> Subject ) );

						if( preg_match( "/=\?(.*?)\?Q\?/i", $new_title ) )
						{
							$new_title = preg_replace( "/=\?(.*?)\?Q\?/i", "", $new_title );
							$new_title = str_replace( "_", " ", substr( $new_title, 0, -1 ) );
						}

						$import_name = preg_replace( "/(.*?) <(.*?)>/i", "\\1", $headers -> fromaddress );
						$import_email = $database -> dbescape( $headers -> reply_toaddress );
						$structure = imap_fetchstructure( $data, $i );

						if( !empty( $structure -> parts ) )
						{

							for( $z = 0, $j = count( $structure -> parts ); $z < $j; $z++ )
							{
								$part = $structure -> parts[ $z ];

								if( $part -> subtype == "PLAIN" )
								{
									$new_story = imap_fetchbody( $data, $i, $z+1 );

									if( $part -> encoding == 3 )
									{
										$new_story = base64_decode( $new_story );
									}


									if( $part -> encoding == 4 )
									{
										$new_story = quoted_printable_decode( $new_story );
									}

									$new_story = $database -> dbescape( $new_story );
								}
							}
						}
						else
						{
							$new_story = imap_body( $data, $i );

							if( $structure -> encoding == 3 )
							{
								$new_story = base64_decode( $new_story );
							}


							if( $structure -> encoding == 4 )
							{
								$new_story = quoted_printable_decode( $new_story );
							}

							$new_story = preg_replace( "/<http(.*?)>/i", "http\\1", $new_story );

							if( $preferences[ 'website_charset' ] == "UTF-8" )
							{
								$new_story = utf8_encode( $new_story );
							}

							$new_story = $database -> dbescape( strip_tags( $new_story ) );
						}


						if( $new_title )
						{
							insertdata( $import_status, $login_username, $import_website, $import_email, $import_channels, $new_title, $new_story, "", $import_teaser, $import_comments, $import_html, $import_smilies, $import_code, $ipaddr, $import_name );

							if( $preferences[ 'contacts_stats_emails' ] )
							{
								$emailsplit = explode( "@", $import_email );
								$query = $database -> dbquery( "SELECT contact_id FROM " . DB_PREFIX . "esselbach_ct_contacts WHERE (contact_domain LIKE '" . $database -> dbescape( $emailsplit[ 1 ] ) . "') LIMIT 1" );

								if( $database -> dbrows( $query ) )
								{
									list( $contact_id ) = $database -> dbrow( $query );
									$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_contacts SET contact_receivedate = now(), contact_receivetraffic = contact_receivetraffic + 1 WHERE contact_id = '" . $contact_id . "'" );
								}
							}
						}

						imap_delete( $data, $i );
					}

					imap_expunge( $data );
				}

				imap_close( $data );
			}
		}
		elseif( $import_source == 2 )
		{

			if( function_exists( "imap_open" ) )
			{
				$data = imap_open( "{" . $import_hostname . "/nntp:119}" . $import_newsgroup, $import_username, $import_password );
				$posts = imap_num_msg( $data );

				if( $input_newsmessages == 1 )
				{
					$importmessages = 20;
				}
				elseif( $input_newsmessages == 2 )
				{
					$importmessages = 40;
				}
				elseif( $input_newsmessages == 3 )
				{
					$importmessages = 60;
				}
				elseif( $input_newsmessages == 4 )
				{
					$importmessages = 80;
				}
				elseif( $input_newsmessages == 5 )
				{
					$importmessages = 100;
				}
				elseif( $input_newsmessages == 6 )
				{
					$importmessages = 250;
				}
				elseif( $input_newsmessages == 7 )
				{
					$importmessages = 500;
				}
				elseif( $input_newsmessages == 8 )
				{
					$importmessages = 1000;
				}
				else
				{
					$importmessages = 10;
				}


				if( $posts )
				{

					for( $i = $posts-$importmessages+1; $i <= $posts; $i++ )
					{
						$headers = imap_header( $data, $i );
						$new_title = $database -> dbescape( $headers -> subject );
						$import_data = $headers -> from;
						$import_email = $database -> dbescape( $import_data[ 0 ] -> mailbox . "@" . $import_data[ 0 ] -> host );
						$import_name = $import_data[ 0 ] -> personal ? $database -> dbescape( $import_data[ 0 ] -> personal ) : $import_email ;
						$new_story = $database -> dbescape( imap_fetchbody( $data, $i, 1 ) );

						if( $new_title )
						{
							insertdata( $import_status, $login_username, $import_website, $import_email, $import_channels, $new_title, $new_story, "", $import_teaser, $import_comments, $import_html, $import_smilies, $import_code, $ipaddr, $import_name );
						}
					}
				}

				imap_close( $data );
			}
		}

		$step++;
		$html -> login( $words_import[ 'IMPORT_NOW' ], $words_import[ 'PROCESSING' ], "index.php?action=importnow&amp;opts=" . $step );
	}
	else
	{
		$query = $database -> dbquery( "SELECT import_status FROM " . DB_PREFIX . "esselbach_ct_import ORDER BY import_id DESC LIMIT 1" );
		list( $import_status ) = $database -> dbrow( $query );

		if( !$import_status )
		{
			$html -> login( $words_import[ 'IMPORT_NOW' ], $words_import[ 'IMPORT_COMPLETE_QUEUE' ], "index.php?action=submissionqueue" );
		}
		else
		{
			$html -> login( $words_import[ 'IMPORT_NOW' ], $words_import[ 'IMPORT_COMPLETE_NEWS' ], "index.php?action=managestories" );
		}
	}
}

function rssstart( $parser, $name, $attrs )
{
	global $item, $tag, $title, $description, $link;

	if( $item )
	{
		$tag = $name;
	}


	if( $name == "ITEM" )
	{
		$item = 1;
	}
}

function rssparse( $parser, $data )
{
	global $item, $tag, $title, $description, $link;

	if( $item )
	{

		if( $tag == "TITLE" )
		{
			$title .= $data;
		}
		elseif( $tag == "DESCRIPTION" )
		{
			$description .= $data;
		}
		elseif( $tag == "LINK" )
		{
			$link .= $data;
		}
	}
}

function rssend( $parser, $name )
{
	global $item, $tag, $title, $description, $link, $otitle, $odescription, $olink;

	if( $name == "ITEM" )
	{
		$otitle[ ] = trim( htmlspecialchars( $title, ENT_QUOTES, CT_ENCODING ) );
		$odescription[ ] = trim( strip_tags( $description ) );
		$olink[ ] = trim( htmlspecialchars( $link, ENT_QUOTES, CT_ENCODING ) );
		$title = "";
		$description = "";
		$link = "";
		$item = 0;
	}
}

function insertdata( $import_status, $login_username, $import_website, $import_email, $import_channels, $new_title, $new_story, $new_link, $import_teaser, $import_comments, $import_html, $import_smilies, $import_blockcode, $ipaddr, $import_name )
{
	global $database, $system, $preferences;

	if( !$import_status )
	{
		$query = $database -> dbquery( "SELECT newsqueue_id FROM " . DB_PREFIX . "esselbach_ct_newsqueue WHERE newsqueue_title = '" . $new_title . "' ORDER BY newsqueue_id" );

		if( !$database -> dbrows( $query ) )
		{
			$import_name = $database -> dbescape( $import_name );
			$import_email = $database -> dbescape( $import_email );
			$new_story_parsed = stripslashes( $new_story );
			$new_story_parsed = $system -> dechomp( $new_story_parsed );
			$new_story_parsed = $system -> smilies( $new_story_parsed );
			$new_story_parsed = $system -> code( $new_story_parsed );
			$new_story_parsed = $database -> dbescape( $new_story_parsed );
			$new_seo = $system -> doseo( $new_title );
			$query = $database -> dbquery( "SELECT COUNT(newsstory_id) FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_seo = '" . $new_seo . "'" );
			list( $seo_stories ) = $database -> dbrow( $query );
			$query = $database -> dbquery( "SELECT COUNT(newsqueue_id) FROM " . DB_PREFIX . "esselbach_ct_newsqueue WHERE newsqueue_seo = '" . $new_seo . "'" );
			list( $seo_queue ) = $database -> dbrow( $query );

			if( ( $seo_stories ) or( $seo_queue ) )
			{
				$new_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
			}

			$ignore_submission = 0;

			if( $preferences[ 'news_submissions_ignore' ] )
			{
				$ignored_words = explode( " ", $preferences[ 'news_submissions_ignore' ] );

				for( $i = 0; $i < count( $ignored_words ); $i++ )
				{

					if( ( preg_match( "/" . $ignored_words[ $i ] . "/i", $new_title ) ) or( preg_match( "/" . $ignored_words[ $i ] . "/i", $new_story ) ) )
					{
						$ignore_submission = 1;
					}
				}
			}

			if( !$ignore_submission )
			{
				if( $new_link )
				{
					$new_link = $system -> get_real_url( $new_link );
				}

				if( $new_story )
				{
					$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsqueue (newsqueue_id, newsqueue_authorid, newsqueue_author, newsqueue_email, newsqueue_status, newsqueue_website, newsqueue_channels, newsqueue_title, newsqueue_seo, newsqueue_rawstory, newsqueue_story, newsqueue_rawextendedstory, newsqueue_extendedstory, newsqueue_link, newsqueue_allowcomments, newsqueue_html, newsqueue_smilies, newsqueue_code, newsqueue_teaser, newsqueue_startdate, newsqueue_fields, newsqueue_filename, newsqueue_mime, newsqueue_size, newsqueue_binary, newsqueue_postip, newsqueue_editip, newsqueue_editadmin) VALUES (NULL, '0', '" . $import_name . "', '" . $import_email . "', '0', '" . $import_website . "', '" . $import_channels . "', '" . $new_title . "', '" . $new_seo . "', '" . $new_story . "', '" . $new_story_parsed . "', '', '', '" . $new_link . "', '" . $import_comments . "', '" . $import_html . "', '" . $import_smilies . "', '" . $import_blockcode . "', '" . $import_teaser . "', now(), '', '', '', '0', '', '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
					$input_page = $database -> dblastinsert();

					if ( $preferences[ 'news_numeric_urls' ] )
					{
						$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsqueue SET newsqueue_seo = '" . $input_page . "' WHERE newsqueue_id = '" . $input_page . "'" );
					}
				}
			}
		}
	}
	else
	{
		$query = $database -> dbquery( "SELECT newsstory_id FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_title = '" . $new_title . "'" );

		if( !$database -> dbrows( $query ) )
		{
			$import_name = $database -> dbescape( $import_name );
			$import_email = $database -> dbescape( $import_email );
			$input_newsstory_description = $system -> description( $new_story );
			$input_newsstory_keywords = $system -> keywords( $new_story );
			$new_story_parsed = $new_story;

			if( !$import_html )
			{
				$new_story_parsed = $system -> dechomp( $new_story_parsed );
			}

			if( $import_smilies )
			{
				$new_story_parsed = $system -> smilies( $new_story_parsed );
			}

			if( $import_blockcode )
			{
				$new_story_parsed = $system -> code( $new_story_parsed );
			}

			$input_newsstory_seo = $system -> doseo( $new_title );
			$query = $database -> dbquery( "SELECT COUNT(newsstory_id) FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE newsstory_seo = '" . $input_newsstory_seo . "'" );
			list( $seo_stories ) = $database -> dbrow( $query );

			if( $seo_stories )
			{
				$input_newsstory_seo .= "_" . substr( md5( rand( 1, 32768 ) ), 1, 4 );
			}

			if( $new_link )
			{
				$new_link = $system -> get_real_url( $new_link );
			}

			if( $new_story )
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsstories (newsstory_id, newsstory_author, newsstory_website, newsstory_channels, newsstory_title, newsstory_seo, newsstory_rawstory, newsstory_story, newsstory_rawextendedstory, newsstory_extendedstory, newsstory_link, newsstory_description, newsstory_keywords, newsstory_teaser, newsstory_comments, newsstory_allowcomments, newsstory_frontpage, newsstory_html, newsstory_smilies, newsstory_code, newsstory_status, newsstory_password, newsstory_date, newsstory_startdate, newsstory_expiredate, newsstory_neverexpire, newsstory_poll, newsstory_pollresults, newsstory_fields, newsstory_sticky, newsstory_views,  newsstory_rating, newsstory_votes, newsstory_source, newsstory_sourceid,  newsstory_activity, newsstory_postip, newsstory_editip, newsstory_editadmin) VALUES (NULL, '" . $login_username . "', '" . $import_website . "', '" . $import_channels . "', '" . $new_title . "', '" . $input_newsstory_seo . "', '" . $new_story . "', '" . $new_story_parsed . "', '', '', '" . $new_link . "', '" . $input_newsstory_description . "', '" . $input_newsstory_keywords . "', '" . $import_teaser . "', '0', '" . $import_comments . "', '1', '" . $import_html . "', '" . $import_smilies . "', '" . $import_blockcode . "', '0', '', now(), now(), now(), '1', '', '', '', '0', '0', '0', '0', '" . $import_name . "', '0', now(), '" . $ipaddr . "', '" . $ipaddr . "', '" . $login_username . "')" );
				$input_page = $database -> dblastinsert();

				if ( $preferences[ 'news_numeric_urls' ] )
				{
					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_newsstories SET newsstory_seo = '" . $input_page . "' WHERE newsstory_id = '" . $input_page . "'" );
				}

				if( $preferences[ 'news_related' ] )
				{
					$news_search = substr( $new_title, 0, 8 );
					$news_limit = $database -> dbescape( $preferences[ 'news_max_related' ] );
					$currentdate = date( "Y-m-d H:i:s", gmmktime() );

					if( !$news_limit )
					{
						$news_limit = 1;
					}
					else
					{
						$news_limit++;
					}

					$query = $database -> dbquery( "SELECT newsstory_id, newsstory_author, newsstory_title, newsstory_seo, newsstory_date FROM " . DB_PREFIX . "esselbach_ct_newsstories WHERE (newsstory_title LIKE '%" . $news_search . "%') AND newsstory_status = '0' AND newsstory_website = '" . $import_website . "' AND newsstory_startdate > '" . $currentdate . "' AND newsstory_neverexpire = '1' ORDER BY newsstory_date DESC LIMIT " . intval( $news_limit ) );

					if( $database -> dbrows( $query ) > 1 )
					{
						while( list( $newsrelated_storyid, $newsrelated_author, $newsrelated_title, $newsrelated_seo, $newsrelated_date ) = $database -> dbrow( $query ) )
						{
							$newsrelated_author = $database -> dbescape( $newsrelated_author );
							$newsrelated_title = $database -> dbescape( $newsrelated_title );

							if( $newsrelated_storyid != $input_page )
							{
								$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_newsrelated (newsrelated_id, newsrelated_story, newsrelated_storyid, newsrelated_author, newsrelated_website, newsrelated_title, newsrelated_seo, newsrelated_date) VALUES (NULL, '" . $input_page . "', '" . $newsrelated_storyid . "', '" . $newsrelated_author . "', '" . $import_website . "', '" . $newsrelated_title . "', '" . $newsrelated_seo . "', '" . $newsrelated_date . "')" );
							}
						}
					}
				}
			}
		}
	}
}
?>